open Runtime_ocaml.Runtime

module DeficitAnterieur = struct
  type t = { annee : integer; valeur : money }
end

let imputation_deficits_au_plus_anciens_
    (revenu_declare : money)
    (deficits_anterieurs : DeficitAnterieur.t array) =
  let rec aux
      (revenu_declare : money)
      (deficits_anterieurs : DeficitAnterieur.t list) =
    match deficits_anterieurs with
    | [] -> revenu_declare, []
    | hd :: tl ->
      if o_gt_mon_mon hd.valeur revenu_declare then
        ( money_of_units_int 0,
          { hd with valeur = o_sub_mon_mon hd.valeur revenu_declare } :: tl )
      else aux (o_sub_mon_mon revenu_declare hd.valeur) tl
  in
  let new_revenu_declare, new_deficits_anterieurs =
    aux revenu_declare
      (List.sort
         (fun (x : DeficitAnterieur.t) (y : DeficitAnterieur.t) ->
           Int.compare (integer_to_int x.annee) (integer_to_int y.annee))
         (Array.to_list deficits_anterieurs))
  in
  new_revenu_declare, Array.of_list new_deficits_anterieurs

let () =
  Runtime_ocaml.Runtime.register_module "Imputation_deficits_anterieurs"
    [
      ( "imputation_d\195\169ficits_au_plus_anciens",
        Obj.repr imputation_deficits_au_plus_anciens_ );
    ]
    "todo-module-hash"
